      subroutine atmos

c     calling routine to standard atmosphere program
c     this routine was downloaded from the internet on 1nov95
c     by Bob Bush.  It was taken from NCAR (National Center
c     for Atmospheric Research: Research Data
c     Archives: SCD Research Data Archives: Software Libraries.
c     http://http.ucar.edu/metapage.html
      
      real alt,p,t,rho

      write(6,*) 'Enter desired altitude in feet'
      read(5,*) alt

      call stdz2p(p,alt,1,t,rho)

c     convert units
      p = p* 0.14550377e-1
      t = (t + 273.15)*9./5.
      rho = rho* 0.194032e-2

      write(6,*) ' *** US Standard Atmosphere, 1976 ***'
      write(6,*) '   alt(ft)     p(psi)      T(R)        rho(slug/ft3)'
      write(6,1001) alt,p,t,rho
 1001 format (1x,4(1pe12.3))

      return
      end
