      subroutine hammer(gamma)
c
c     program to compute hammershock speed given M1 approaching
c
   10 CONTINUE
C
      write(6,*)
      write(6,*) 'enter inflow Mach number (0 returns to main menu)'
      read(5,*) amp
      if ( amp .eq. 0. ) go to 100
c
c     solve a quadratic equation for the Mach number 
c       relative to the shock (see R.H. Bush)
c
      a = 1
      b = - (gamma+1)*amp/2
      c = -1
c
      rad = sqrt(b*b - 4*a*c)
      am1 = (-b + rad)/(2*a)
c
c     normal shock relations for static conditions
      p2rp1 = ( 2.*gamma*am1*am1 - (gamma - 1.) ) / (gamma + 1.)
      t2rt1 = p2rp1 * ( (gamma - 1.)*am1*am1 + 2 ) 
     1              / ( (gamma + 1.)*am1*am1 )
c
c      write(6,*) 'Mach number relative to shock = ',am1
      write(6,*) 'Mach number of shock (relative to inlet) = ',am1-amp
      write(6,*) 'Pressure rise (P2/P1)    = ',p2rp1
      write(6,*) 'Temperature rise (T2/T1) = ',t2rt1
c
      go to 10
c
  100 continue
c
      return
      end
