      SUBROUTINE masmac ( GAMMA )
C
C  NAME
C    MASMAC - MASs flow/MACh number calculator.
C
C  ARGUMENTS
      REAL                GAMMA
C
C  COMMONS
C
C  SYNOPSIS
C     This routine calculates the change in mass flow required to effect
C     a change in inflow Mach number.  The user inputs a current mass
C     flow, inflow Mach number, and desired change in inflow Mach number.
C     The code then computes an estimate of the change in mass flow
C     required to drive the inflow Mach number to the desired value.
C
C  END
C
      REAL                 MASFLO, MACHIN
C
      WRITE(*,*)' Enter current exit mass flow (lbm/sec) and'
      WRITE(*,*)'  inflow Mach number.'
      READ(*,*) MASFLO, MACHIN
      WRITE(*,*)' Enter change in inflow Mach number desired:'
      READ(*,*) DELMAC
      DELMAS = ( 1. / MACHIN - .5*(GAMMA-1.)*MACHIN / ( 1. +
     $      .5*(GAMMA-1.)*MACHIN*MACHIN ) ) * DELMAC * MASFLO
      WRITE(*,*)' Mass flow should change by ', DELMAS,
     $          ' lbm/sec.'
      WRITE(*,*)
      WRITE(*,*)' NOTE:  THIS IS ONLY AN ESTIMATE!'
      WRITE(*,*)'        DON''T BET THE FARM ON THIS NUMBER!'
      WRITE(*,*)' Press <CR> to continue...'
      READ(*,'(I5,$)')IANS
C
      RETURN
      END
