      subroutine cgns_delete_base ( CGNS_file_index, base )
c
c     routine to delete a base existing in a CGNS file
c
      implicit none
c
      include 'cgnslib_f.h'
c
      integer      CGNS_file_index
c local
      integer          nbases,base
      integer          ier
      double precision ADFid,root_id
      logical          check_adf_error
c
      if ( base .eq. 0 ) then
c       Choose base to delete
        call cgns_list_bases ( CGNS_file_index, nbases )
        if ( nbases .le. 0 ) then
          write(6,*) '  There are no bases in the working file to'
     &              ,' delete'
          write(6,*) '  Read a base first'
          go to 500
        else if ( nbases .eq. 1 ) then
          write(6,*) '  Only one base found... Selecting base 1'
          base = 1
        else
          write(6,*) '  Enter the base you would like to delete'
          read(5,*) base
        end if
      end if
c
c     get adf id for base
      call cg_base_id_f ( CGNS_file_index, base, ADFid, ier )
      if ( ier .ne. 0 ) call cg_error_exit_f
c
c     get the root id
      call adfgrid ( ADFid, root_id, ier )
      if ( check_adf_error ('  cgns_delete_base: get root id', ier ) ) 
     &                     go to 500
c
c     delete the base node (and children)
      call adfdel ( root_id, ADFid, ier )
      if ( check_adf_error ('  cgns_delete_base: get root id', ier ) ) 
     &                     go to 500

  500 continue
      return
      end
