      program ftu
c
c     File Transfer Utility
c
      implicit none
c
      include 'cgnslib_f.h'

      integer mode
      character*80 version
      character*80 wf_name
      integer      CGNS_file_index
      integer      ier
      integer      base

      call pgmver(version)
      write(*,*) 'Version: ', version
c
      wf_name = ' '
      CGNS_file_index = 0
c
c     entry to program
  100 continue

c     Menu
      write(6,*) ' '
      write(6,*) '***********************************************'
      write(6,*) '*                                             *'
      write(6,*) '*    FFFFF   TTTTTTT     U    U               *'
      write(6,*) '*    F          T        U    U               *'
      write(6,*) '*    FFFF       T        U    U               *'
      write(6,*) '*    F          T        U    U               *'
      write(6,*) '*    File       Transfer  UUUUtility          *'
      write(6,*) '*                                             *'
      write(6,*) '***********************************************'
      write(6,*) ' Version: ', version
      write(6,*) '  0 - exit'
      write(6,*) '  1 - Open the Working CGNS Database'
      write(6,*) '  2 - Fill Working CGNS Database'
      write(6,*) '  3 - Output CFD Database'
      write(6,*) '  4 - Interrogate a cgns database'
      write(6,*) '  5 - Manipulate a base'
      write(6,*) '  6 - Misc. scalar calculations'
      write(6,*) '  7 - Delete a base'
      write(6,*) '  8 - List bases'
      write(6,*) ' enter mode'
      read(5,*) mode

      if ( mode .eq. 0 ) then
        go to 500
      else if ( mode .eq. 1 ) then
        call open_cgns_database ( CGNS_file_index, wf_name )
      else if ( mode .eq. 2 ) then
        call create_working_file ( CGNS_file_index, wf_name )
      else if ( mode .eq. 3 ) then
        call output_database ( CGNS_file_index, wf_name )
      else if ( mode .eq. 4 ) then
        call cg_ftubrowse_f ( CGNS_file_index )
      else if ( mode .eq. 5 ) then
        call manipu ( CGNS_file_index )
c       close and re-open the base to be sure the file is clean
        call cg_close_f ( CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
        CGNS_file_index = 0
        call cg_open_f ( wf_name, MODE_MODIFY, CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
      else if ( mode .eq. 6 ) then
        call gas
      else if ( mode .eq. 7 ) then
        base = 0
        call cgns_delete_base ( CGNS_file_index, base )
c       close and re-open the base to be sure the file is clean
        call cg_close_f ( CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
        CGNS_file_index = 0
        call cg_open_f ( wf_name, MODE_MODIFY, CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
      else if ( mode .eq. 8 ) then
         call cgns_list_bases ( CGNS_file_index, base )
         write(6,*) '  press <cr> to continue'
         read(5,*)
      else
        write(6,*) 'Unrecognized mode'
      end if

c     go back to top
      go to 100

c     exit from program
  500 continue
c
c     close working file if open
      if ( CGNS_file_index .ne. 0 ) then
        call cg_close_f ( CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) then
          write(6,*) '  ftu: error: closing working file '
          call cg_error_exit_f
        end if
      end if

      stop
      end
