      subroutine open_cgns_database ( CGNS_file_index, wf_name )
c
c     routine to open the working database
c
      implicit none
c
      include 'cgnslib_f.h'
c
      integer        CGNS_file_index
      character*80   wf_name
c
      integer        ier
c
c
      if ( CGNS_file_index .ne. 0 ) then
c       a working file is already open
c         close it and ask for a new name
        write(6,*) '  closing working file: ',trim(wf_name)
        call cg_close_f ( CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
        CGNS_file_index = 0
        write(6,*) 'Enter a name for the new working database'
        read (5,*) wf_name
      else
c       no working file open, set default name
        wf_name = 'FTU_Work.cgns'
      end if
c
c     now working file is not open, but it may or may not already exist
c     see if it exists:
      call cg_open_f ( wf_name, MODE_MODIFY, CGNS_file_index, ier )
      if ( ier .ne. ALL_OK ) then
c       assume did not exist, need to create a new one
        write(6,*) '  creating new working file: ',wf_name
ccc        if ( ier .ne. ALL_OK ) call cg_error_exit_f
        CGNS_file_index = 0
        call cg_open_f ( wf_name, MODE_WRITE, CGNS_file_index, ier )
        if ( ier .ne. ALL_OK ) call cg_error_exit_f
      else
c       it must have existed,
        write(6,*) '  opening existing working file: ',wf_name
      end if
c
      write(6,*)
      write(6,*) 'press <cr> to continue'
      read(5,*)
c
      return
      end
