       subroutine output_database (CGNS_file_index, wf_name)
c
c************************************************************************
c***                  Jeff Math, Bob Bush, Stephan Staudacher         ***
c***             Simulation and Modeling Group                        ***
c***      Aeromechanical, Chemical, and Fluid Systems                 ***
c***          United Technologies Research Center                     ***
c************************************************************************
c
      implicit none
c
      integer        CGNS_file_index
      character*80   wf_name
c
      integer        imode
      character*1    ans
      character      cfile*80
      integer        i,iclen
      integer        output_base
      integer        nbases
c
c     initialize
      imode = 0
      iclen = 0
      cfile = ' '
c
c     check if working file exists
c     if it does, all set, if not error out
      if ( CGNS_file_index .eq. 0 ) then
        write(6,*) '  output_database: error: no working file exists'
        write(6,*) '     cannot output'
        go to 500
      end if
c
  100 continue
      write (6,*) ' Output Database File Menu '
      write (6,*) ' 0 - return to main menu'
      write (6,*) ' Write working file info to:'
      write (6,*) ' 1 - cgns format'
      write (6,*) ' 2 - plot3d format'
      write (6,*) ' 3 - Wind Common File Format'
      write (6,*) ' enter mode:'
      read (5,*) imode
c
      if ( imode .eq. 0 ) then
        go to 500
      else
c       write a file
c
c       determine what to write
        call cgns_list_bases ( CGNS_file_index, nbases )
        write(6,*) '  Enter base to output (0 for all bases)'
        read(5,*) output_base
c
c       check validity
        if ( imode .eq. 3 .and. output_base .eq. 0 ) then
          write(6,*) '  cannot currently output all bases in cff'
          go to 100
        else if ( imode .eq. 1 .and. output_base .ne. 0 ) then
          write(6,*) '  currently must output all bases as cgns'
          go to 100
        end if
c
c       get file name
        write(6,*)
     .      ' Enter file name to write (max. 80 characters, no spaces)'
        read (5,'(a80)') cfile
c
c       parse file name
        do 10 i=1,80
          if (cfile(i:i).eq.' ') then
             iclen = i - 1
             goto 11
          endif
   10   continue
        iclen = 80
   11   continue
c
        if ( imode .eq. 1 ) then
c         cgns
          call write_cgns(wf_name,cfile,iclen)
c
        else if ( imode .eq. 2 ) then
c         plot3d
          call setupplot3d(1,CGNS_file_index,
     &                     cfile,iclen,output_base)
c
        else if ( imode .eq. 3 ) then
c         Wind Common File Format (cff)
          call cf_to_cgns(1,wf_name, CGNS_file_index,
     &                    cfile,iclen,output_base)
c
        else
          write(6,*) ' unrecognized file format'
        end if
      end if
c
c     go back to see if want something else
      go to 100
c
  500 continue
      return
      end
