c
       subroutine setupplot3d (convert_mode, CGNS_file_index,
     &                         cfile , iclen, addfile)
c
c   file transfer utility to read from and write to a large array of file formats
c
c**********************************************************************************
c**********************************************************************************
c**********************************************************************************
c***                            Jeff Math, Bob Bush                             ***
c***                       Simulation and Modeling Group                        ***
c***                Aeromechanical, Chemical, and Fluid Systems                 ***
c***                    United Technologies Research Center                     ***
c**********************************************************************************
c**********************************************************************************
c**********************************************************************************
c
c       implicit none
       include 'commons.i'

c----------------------------------------------------------------------------------
c define attributes
       integer convert_mode, iclen, addfile
       integer CGNS_file_index
c
       character cfile
       character char8*8, cfmt*10
c      
cst       call system ("clear")
       if (convert_mode.eq.0) char8='  input '
       if (convert_mode.eq.1) char8=' output '
c
c Read
c
       if (convert_mode.eq.0) then
          write(6,'(//26x,a28//)') '  MENU OF INPUT FILE TYPES  '
          write(6,'(25x,a29)') ' GRID ONLY (UNBLANKED)     11'
          write(6,'(25x,a29)') ' GRID ONLY (BLANKED)       12'
          write(6,'(25x,a29)') ' SOLUTION ONLY             13'
cjam      write(6,'(25x,a29)') ' SOLN W/UNBLANKED GRID     14'
cjam      write(6,'(25x,a29)') ' SOLN W/BLANKED GRID       15'
cst       write(6,'(25x,a29)') ' FUNCTION ONLY             16'
cjam      write(6,'(25x,a29)') ' FUNC W/UNBLANKED GRID     17'
cjam      write(6,'(25x,a29)') ' FUNC W/BLANKED GRID       18'
          write(6,'(/a22)') ' Enter file type index'
          read (5,*) itype
cst          itype=11
       endif
       if (convert_mode.eq.1) then
          write(6,'(//26x,a28//)') '  MENU OF OUTPUT FILE TYPES  '
          write(6,'(25x,a29)') ' GRID ONLY (UNBLANKED)     11'
          write(6,'(25x,a29)') ' GRID ONLY (BLANKED)       12'
          write(6,'(25x,a29)') ' SOLUTION ONLY             13'
          write(6,'(/a22)') ' Enter file type index'
          read (5,*) itype
        endif
c
c   data storage format
c
       write(6,'(/a78)') ' Enter'//char8//'data storage format - '//
     .                   '(1) formatted, (2) unformatted, (3) binary'
       read (5,*) istor
cst       istor=1
c
c   file precision
c
       write(6,'(/a53)')
     .        ' Enter'//char8//'file precision - (1) single, (2) double'
       read (5,*) iprec
cst       iprec=1
c
c   model dimension
c
       igrdim=3 !default
       isoldim=5 !default
       if (convert_mode.eq.0) then
         if (itype.lt.13)then
           write(6,'(/a42)')
     .     ' Enter'//char8//'model dimension grid - <= 3'
           read (5,*) igrdim
         endif
cst       igrdim=3
c
c   check that grid and solution are same size
c
         if (itype.ge.13) then
           write(6,'(/a59)')
     .    ' (make sure file has dimensions same as associated grid!!!)'
           write(6,'(/a46)')
     .       ' Enter'//char8//'model dimension solution - <= 5'
           read (5,*) isoldim
         endif
cst       isoldim=4
c
c   parametric dimension
c
         write(6,'(/a53)')
     .        ' Enter'//char8//'parametric dimension (ijk) - 1, 2, or 3'
         read (5,*) iidim
c
c   multiblock mode
c
cst       write(6,'(/a43)') ' Enter 1 if single block format, else non-1'
cst       read (5,*) imb
         imb=2
       endif
c
c   iblank mode
c
       iblnk = 0
       if (itype.eq.12.or.itype.eq.15.or.itype.eq.18) iblnk = 1
c
c   open plot3d file
c
       iunit = 11
       if (istor.eq.1)
     .        open (unit=iunit, file=cfile(1:iclen), form='formatted')
       if ((istor.eq.2).or.(istor.eq.3))
     .        open (unit=iunit, file=cfile(1:iclen), form='unformatted')
c
c   access read/write routines
c      write cgns file immediately
c
c   read
c
       if (convert_mode.eq.0) call read_plot3d (CGNS_file_index,
     &                                          cfile,iclen,addfile)
       if (convert_mode.eq.1) call write_plot3d(CGNS_file_index,
     &                                          cfile,iclen,addfile)
c
       close (iunit)
       return
       end
