c
        subroutine write_plot3d(CGNS_file_index,cfile,iclen,addfile)
c
c   write plot3d file format
c      (extracted from read_cgns code)
c
        implicit none

        include 'cgnslib_f.h'
cjam
        include 'commons.i'
c

	parameter (Nglobal = 500)
c define arguments
c
        integer   CGNS_file_index
        character cfile*80
        integer iclen
        integer   addfile
c
        integer j,k
	integer ier, n, iclen_cgns, nglobal, izone, i, type, imore
	integer nbases, index_dim, nzones, zone_dim(Ndim*2)
        integer phys_dim, zonetype, fiidim, figrdim
	integer ncoords, nsols, nfields, location, nsize, datatype
        integer nfieldst
        integer mass, length, time, temp, deg
        integer narrays, iarray, fieldindex, fieldcheck
	integer cg, base, zone, coord, sol, field, discr
	integer nndim, dim_vals(12), rind(6), ndiscrete, num
        integer   iref
        integer      iclass,imass,ilen,itime,itemp,iangle
        integer      DataDim,DataType,DimVal
        integer      nholes,nhole
        integer      location, pt_set_type, nptsets, nptset, npts, npt
        integer      ib,jb,kb,ib1,ib2,jb1,jb2,kb1,kb2
        character*32 basename, zonename, solname, fieldname 
	character*32 coordname, holename, connectname
	character*32 boconame, donorname
	character*32 name
        character*39 refstr
        integer,  allocatable:: ibla(:,:,:)
        integer, allocatable:: pnts(:,:,:)
        real         data_sin
        real, allocatable:: xyz(:)
        real, allocatable:: values(:)
        double precision, allocatable:: Dxyz(:)
        double precision, allocatable:: Dvalues(:)
	real, allocatable:: x_real(:)
        real, allocatable:: y_real(:)
        real, allocatable:: z_real(:)
        double precision, allocatable:: x_double(:)
        double precision, allocatable:: y_double(:)
        double precision, allocatable:: z_double(:)
	real, allocatable:: data_single(:)
	double precision, allocatable:: data_double(:)
c
        if (istor.eq.3) then
           write(6,'(a20)') ' not yet implemented'
cjam       call ccwrite
           return
        endif
c
        cg = CGNS_file_index
c
!    *** select base
         base = addfile
         if ( addfile .eq. 0 ) then
           write(6,*) '  WARNING: can only ouput one base to plot3d'
           write(6,*) '           writing base 1 only'
           base = 1
         end if
c
!    *** repeat information
	 call cg_base_read_f(cg, base, basename, index_dim,
     &                        phys_dim, ier)
	 if (ier .eq. ERROR) call cg_error_exit_f
	 write(6,'(3a/a,i2)')'BaseName = "',basename,'"', 
     &                        'index_dimension=',index_dim,
     &                        'phys_dimension=',phys_dim
         iidim=index_dim
! *** base attribute:  GOTO base node
	 call cg_goto_f(cg, base, ier, 'end')
         if (ier .eq. ERROR) call cg_error_exit_f

	 call cg_nzones_f(cg, base, nzones, ier)
	 if (ier .eq. ERROR) call cg_error_exit_f
	 write(6,'(a,i2)')'nzones=',nzones
         if ( nzones .gt. nzonemax ) then
           write(6,*) '  write_plot3d: number of zones in base'
     &               ,' too big for parameter in commons0.i'
           write(6,*) '    max zones dimensioned: ',nzonemax
           return
         end if
cjam
c   header - multi-block - formatted, unformatted, or binary
c
         if (imb.ne.1.and.istor.eq.1) write(iunit,*) nzones
         if (imb.ne.1.and.istor.ge.2) write(iunit  ) nzones
c
c data
c
! *** zone
   ! *** read in and write zone dimensions
         do zone=1, nzones
	     call cg_zone_read_f(cg, base, zone, zonename,
     .            zone_dim, ier)
	     if (ier .eq. ERROR) call cg_error_exit_f
             if ( iidim .eq. 3 ) then
c              all is well with the world
             else if (iidim.eq.2) then
c              re-arrange for 3 dimensions
               zone_dim(6) = 1
               zone_dim(5) = zone_dim(4)
               zone_dim(4) = zone_dim(3)
               zone_dim(3)=1
             else
               write(6,*) '  write_plot3d: error: do not know how to'
     &                   ,' handle file dimensioned by: ',iidim
             end if
             do coord = 1, iidim
               zone_dim0(coord,zone) = zone_dim(coord)
             end do
cbb          write(6,'(a,i2,3a)')'Name of Zone',zone,' is "',zonename,'"'
	     if (zone_dim(1)*zone_dim(2)*zone_dim(3) .gt. nptsmax) then
	        write(6,*) 'Coord. array not large enough for Zone',zone
                write(6,*) 'Increase Parameter nptsmax'
	        ier=ERROR
                call cg_error_exit_f
             end if
             call cg_zone_type_f(cg,base,zone,zonetype,ier)
             if (zonetype.eq.Unstructured)then
                write(6,*) 'Sorry, I can  not write Unstructured Grid ',
     .                     'into Plot3D-File!'
                return
             endif
         end do
         if (istor.eq.1) write(iunit,*)
     .         ((zone_dim0(coord,izone), coord=1,iidim), izone=1,nzones)
         if (istor.ge.2) write(iunit  )
     .         ((zone_dim0(coord,izone), coord=1,iidim), izone=1,nzones)
c
c        flag determining if found a reference state in this base
         iref = 0
c
	 do zone=1, nzones
	    call cg_zone_read_f(cg, base, zone, zonename, zone_dim, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
            if ( iidim .eq. 3 ) then
c             all is well with the world
            else if (iidim.eq.2) then
c             re-arrange for 3 dimensions
              zone_dim(6) = 1
              zone_dim(5) = zone_dim(4)
              zone_dim(4) = zone_dim(3)
              zone_dim(3)=1
            else
              write(6,*) '  write_plot3d: error: do not know how to'
     &                  ,' handle file dimensioned by: ',iidim
            end if
            nsize=zone_dim(1)*zone_dim(2)*zone_dim(3)
            write(6,*) '  working on zone: ',zone,' dims: '
     &                    ,(zone_dim(coord),coord=1,iidim)

c! *** zone coordinate attribute:  GOTO GridCoordinates_t node
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'GridCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then
!     *** reading in grid coords information
              call cg_units_read_f(mass, length, time, temp, deg, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
cbb              if (ier .eq. ALL_OK) write(6,'(2a)') 
cbb     &            'Dimensional Units for GridCoordinates_t: ',
cbb     &            LengthUnitsName(length)
        ! *** coordinate array
	      call cg_narrays_f(narrays, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
cbb             write(6,'(a,i1,a)') 'GridCoordinates_t contains ',
cbb     &                            narrays,' arrays'

        ! *** Old functions to read coordinates
	      call cg_ncoords_f(cg, base, zone, ncoords, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
cbb                write(6,'(a,i2)')'no. of coordinates=',ncoords
              
	      do coord=1, ncoords
	  	call cg_coord_info_f(cg, base, zone, coord, datatype,
     &                               coordname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
cbb               write(6,'(a,i1/2a/3a)')'coord #',coord, 
cbb     &            ',   datatype=',DataTypeName(datatype), 
cbb     &            ',   name="',coordname,'"'
	      enddo

         !      Local subroutine:
                if (datatype .eq. RealSingle) then
                  allocate(x_real(nsize))
                  allocate(y_real(nsize))
                  allocate(z_real(nsize))
                  call read_coord_as_real(cg, base, zone, nsize,
     &               zone_dim, x_real, y_real, z_real)
               elseif (datatype .eq. RealDouble) then
                  allocate(x_double(nsize))
                  allocate(y_double(nsize))
                  allocate(z_double(nsize))
                  call read_coord_as_double(cg, base, zone, nsize, 
     &              zone_dim, x_double, y_double, z_double)
               endif
              if (itype.eq.11.or.itype.eq.12.or.itype.eq.14.or.
     .            itype.eq.15.or.itype.eq.17.or.itype.eq.18) then
c
c   fill xyz0 or Dxyz0 array; allow for precision changes
c
                 if (datatype .eq. RealSingle) then
                    if (iprec.eq.1) then
                       do 110 pos=1,nsize
                          xyz0(pos,1) = x_real(pos)
                          xyz0(pos,2) = y_real(pos)
  110                     xyz0(pos,3) = z_real(pos)
                    else
                       do 120 pos=1,nsize
                          Dxyz0(pos,1) = x_real(pos)
                          Dxyz0(pos,2) = y_real(pos)
  120                     Dxyz0(pos,3) = z_real(pos)
                    endif
c
                 elseif (datatype .eq. RealDouble) then
                    if (iprec.eq.2) then
                       do 130 pos=1,nsize
c                          write (6,*) Dxyz0(pos,1) 
                          Dxyz0(pos,1) = x_double(pos)
                          Dxyz0(pos,2) = y_double(pos)
  130                     Dxyz0(pos,3) = z_double(pos)
                    else
                       do 140 pos=1,nsize
c                          write (6,*) xyz0(pos,1) 
                          xyz0(pos,1) = x_double(pos)
                          xyz0(pos,2) = y_double(pos)
  140                     xyz0(pos,3) = z_double(pos)
                    endif
                 endif !datatype
                 if (allocated(x_real)) deallocate (x_real)
                 if (allocated(y_real)) deallocate (y_real)
                 if (allocated(z_real)) deallocate (z_real)
                 if (allocated(x_double)) deallocate (x_double)
                 if (allocated(y_double)) deallocate (y_double)
                 if (allocated(z_double)) deallocate (z_double)
c
c                fill iblank
                 if ( iblnk .eq. 1 ) then
c
                   if ( iidim .ne. 3 ) then
                     write(6,*) '  write_plot3d: error: cannot handle'
     &                         ,' non 3D hole data for iblank'
                     return
                   end if
c
c                  allocate storage
                   allocate ( ibla(zone_dim(1),zone_dim(2),zone_dim(3)))
c
c                  initialize ibla
                   ibla = 1
c
c                  read holes
                   nholes = 0
                   call cg_nholes_f ( cg, base, zone, nholes, ier )
                   if ( ier .eq. ERROR ) call cg_error_exit_f
                   if ( nholes .eq. 0 ) then
                     write(6,*) '  write_plot3d: warning: writing'
     &                         ,' iblank but no holes in zone: ',zone
                   end if
c
c                  loop through holes
                   do nhole = 1,nholes
c
c                    read hole info
                     call cg_hole_info_f ( cg,base,zone,nhole,
     &                  holename,location,pt_set_type,nptsets,npts,ier)
                     if ( ier .eq. ERROR ) call cg_error_exit_f
c
c                    check valid pt_set_type
                     if ( pt_set_type .eq. PointList .or.
     &                    pt_set_type .eq. PointRange ) then
c                      PointRange or PointList - understood
                     else
                       print *, '  write_plot3d: error: point set type '
     &                         ,'not implemented: type: ',pt_set_type
                       return
                     end if
c
c                    check for consistency
                     if ( nptsets .eq. 1 ) then
c                      can be point list or point range
                     else
                       if ( pt_set_type .eq. PointRange .and. 
     &                      npts .eq. 2 ) then
c                        this is what is needed if nptsets>1
                       else
                         print *, '  write_plot3d: error: multiple'
     &                           ,' point sets defined, but not'
     &                           ,' PointRange type, not allowed'
                         return
                       end if
                     end if
c
c                    read points defining boundary patch
                     allocate ( pnts ( 3, npts, nptsets ) )
                     call cg_hole_read_f (cg,base,zone,nhole,
     &                                    pnts, ier )
                     if ( ier .eq. ERROR ) call cg_error_exit_f
c
c                    loop through point sets
                     do nptset = 1,nptsets
c
c                      loop through points (range pnts(*,1) to pnts(*,2) or
c                                individual list of points in pnts)
                       if ( pt_set_type .eq. PointList ) then
c                        over-write iblank info
                         do npt = 1,npts
                           ib = pnts(1,npt,nptset)
                           jb = pnts(2,npt,nptset)
                           kb = pnts(3,npt,nptset)
                           ibla ( ib,jb,kb ) = -2
                         end do
                       else if ( pt_set_type .eq. PointRange ) then
c                        over-write iblank info
                         ib1 = pnts(1,1,nptset)
                         ib2 = pnts(1,2,nptset)
                         jb1 = pnts(2,1,nptset)
                         jb2 = pnts(2,2,nptset)
                         kb1 = pnts(3,1,nptset)
                         kb2 = pnts(3,2,nptset)
                         do kb = kb1,kb2
                           do jb = jb1,jb2
                             do ib = ib1,ib2
                               ibla ( ib,jb,kb ) = -2
                             end do
                           end do
                         end do
                       end if
                     end do     !loop over point sets
c
                   end do       !loop over holes
c
c                  fill iblank, allow for precision
                   if ( iprec .eq. 1 ) then
                     pos = 0
                     do ib = 1,zone_dim(1)
                       do jb = 1,zone_dim(2)
                         do kb = 1,zone_dim(3)
                           pos = pos+1
                           iblank_real(pos) = ibla(ib,jb,kb)
                         end do
                       end do
                     end do
                   else
                     pos = 0
                     do ib = 1,zone_dim(1)
                       do jb = 1,zone_dim(2)
                         do kb = 1,zone_dim(3)
                           pos = pos+1
                           iblank_double(pos) = ibla(ib,jb,kb)
                         end do
                       end do
                     end do
                   end if
                   if ( allocated(ibla) ) deallocate ( ibla )
                   if ( allocated(pnts) ) deallocate ( pnts )
                 end if              !end of iblank filling
c
c      formatted, single precision, non-iblanked
c      formatted, single precision, iblanked
c      formatted, double precision, non-iblanked
c      formatted, double precision, iblanked
c      unformatted/binary, single precision, non-iblanked
c      unformatted/binary, single precision, iblanked
c      unformatted/binary, double precision, non-iblanked
c      unformatted/binary, double precision, iblanked
c
                 if (istor.eq.1.and.iprec.eq.1.and.iblnk.ne.1) write
     .    (iunit,*) (( xyz0(pos,coord), pos=1,nsize), coord=1,ncoords)
                 if (istor.eq.1.and.iprec.eq.1.and.iblnk.eq.1) write
     .    (iunit,*) (( xyz0(pos,coord), pos=1,nsize), coord=1,ncoords),
     .                  (iblank_real(pos), pos=1,nsize)
                 if (istor.eq.1.and.iprec.eq.2.and.iblnk.ne.1) write
     .    (iunit,*) ((Dxyz0(pos,coord), pos=1,nsize), coord=1,ncoords)
                 if (istor.eq.1.and.iprec.eq.2.and.iblnk.eq.1) write
     .    (iunit,*) ((Dxyz0(pos,coord), pos=1,nsize), coord=1,ncoords),
     .                (iblank_double(pos), pos=1,nsize)
c
                 if (istor.ge.2.and.iprec.eq.1.and.iblnk.ne.1) write
     .    (iunit  ) (( xyz0(pos,coord), pos=1,nsize), coord=1,ncoords)
                 if (istor.ge.2.and.iprec.eq.1.and.iblnk.eq.1) write
     .    (iunit  ) (( xyz0(pos,coord), pos=1,nsize), coord=1,ncoords),
     .                  (iblank_real(pos), pos=1,nsize)
                 if (istor.ge.2.and.iprec.eq.2.and.iblnk.ne.1) write
     .    (iunit  ) ((Dxyz0(pos,coord), pos=1,nsize), coord=1,ncoords)
                 if (istor.ge.2.and.iprec.eq.2.and.iblnk.eq.1) write
     .    (iunit  ) ((Dxyz0(pos,coord), pos=1,nsize), coord=1,ncoords),
     .                (iblank_double(pos), pos=1,nsize)
c
              endif     ! if itype
c
            endif       ! if GridCoordinates_t exists
c
! *** solution
	    if(itype.eq.13)then
              nsols=0
	      call cg_nsols_f(cg, base, zone, nsols, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,'(i1,3a)') nsols,' FlowSolution_t node(s)',
     &              'found for ',zonename
              if (nsols.gt.1) then
                write (6,*) 'Please enter desired Solution Number'
                read (5,*) sol
              elseif (nsols.eq.0) then
                write (6,*) 'No Solution available'
                return
              else
                sol=1
              endif 
    
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'FlowSolution_t', sol, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

	! *** FlowSolution_t attribute:  DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,'(a,i1,a,i1,a)') ' FlowSolution_t #',sol,
     &              ' contains ',narrays,' solution arrays'

	! *** FlowSolution_t attribute:  GridLocation
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,'(2a)')'  The solution data are recorded at the ',
     &                 GridLocationName(location)
              if (location.ne.Vertex) then
                write (6,*) 'Solution not stored at Vertices, abort'
                return
              endif
      	      call cg_sol_info_f(cg, base, zone, sol, solname,
     &                           location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,'(a,i1,a/3a/2a)')'sol #',sol,':',
     &                    '   solname="',solname,'"',
     &                    '   location=',GridLocationName(location)

   	! *** solution field
	      call cg_nfields_f(cg, base, zone, sol, nfields, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,'(a,i1)')'  nfields=',nfields
              fieldcheck = 1

 	      do field=1, nfields
	        call cg_field_info_f(cg, base, zone, sol, field,
     &                               type, fieldname, ier)
 	        if (ier .eq. ERROR) call cg_error_exit_f
                write(6,'(a,i1,a/3a/2a)')'  field #',field,':',
     &                    '   fieldname="',fieldname,'"',
     &                    '   datatype=',DataTypeName(type)


                  if (allocated(data_single)) deallocate (data_single)
                  if (allocated(data_double)) deallocate (data_double)
                  allocate(data_double(nsize))
                  allocate(data_single(nsize))

	     ! *** Local function
                call read_field(cg,base,zone,sol,zone_dim,fieldname,
     .                            data_single,data_double,nsize,iprec)
c
                if (itype.ge.13.and.itype.le.15) then
c
c   fill values0 or Dvalues0 array; allow for precision changes
c
                   fieldindex = 0
                   if (fieldname(1:7).eq. 'Density') fieldindex=1
                   if (fieldname(1:9).eq. 'MomentumX') fieldindex=2
                   if (fieldname(1:9).eq. 'MomentumY') fieldindex=3
                   if (fieldname(1:9).eq. 'MomentumZ') fieldindex=4
                   if ((isoldim.eq.4).and.
     .                 (fieldname(1:23).eq.'EnergyStagnationDensity'))
     .                  fieldindex=4
                   if ((isoldim.eq.5).and.
     .                 (fieldname(1:23).eq.'EnergyStagnationDensity'))
     .                  fieldindex=5     
c---------------------------
c      this will temporarily create a plot3d file containing
c      rotating coordinates - may want to change later...

            if (fieldname(1:17).eq. 'RotatingMomentumX') fieldindex=2
            if (fieldname(1:17).eq. 'RotatingMomentumY') fieldindex=3
            if (fieldname(1:17).eq. 'RotatingMomentumZ') fieldindex=4
            if ((isoldim.eq.4).and.
     .          (fieldname(1:31).eq.'RotatingEnergyStagnationDensity'))
     .           fieldindex=4
            if ((isoldim.eq.5).and.
     .          (fieldname(1:31).eq.'RotatingEnergyStagnationDensity'))
     .           fieldindex=5     
c---------------------------
                   fieldcheck=(fieldindex+1)*fieldcheck
                   nfieldst = max(nfieldst,fieldindex)

                   if ( fieldindex .ne. 0 ) then
                     if (type .eq. RealSingle) then
                        if (iprec.eq.1) then
                          do 210 pos=1,nsize
  210                       values0(pos,fieldindex) = data_single(pos)
                        else
                          do 220 pos=1,nsize
 220                        Dvalues0(pos,fieldindex) = data_single(pos)
                        endif
c
                     elseif (type .eq. RealDouble) then
                        if (iprec.eq.2) then
                          do 230 pos=1,nsize
 230                        Dvalues0(pos,fieldindex) = data_double(pos)
                        else
                          do 240 pos=1,nsize
  240                       values0(pos,fieldindex) = data_double(pos)
                        endif
                     endif
                   end if
                endif
c
 	      enddo				! field loop
              nfields = nfieldst
c
c Checking if sufficient database
              if (((fieldcheck.ne.120).and.(isoldim.eq.4)).or.
     .          ((fieldcheck.ne.720).and.(isoldim.eq.5)))then
                write(6,*)'Solution nodes do not contain sufficient ',
     .                    'data, abort'
                return
              endif
c
c *** read reference state
c             check for reference state under zone node
              call cg_goto_f(cg,base,ier,'Zone_t',
     .                              zone,'end')
              if (ier.ne.0) call cg_error_exit_f
              call cg_state_read_f(refstr,ier)
              if (ier.eq.ERROR) call cg_error_exit_f
              if ( ier .eq. ALL_OK ) then
                iref = 1
                write(6,*) '  Reference state found under zone node'
     &                     ,zone
                call cg_goto_f (cg,base,ier,'Zone_t', zone,
     .                          'ReferenceState_t', 1, 'end')
              else if ( iref .eq. 0 ) then
c               check under base node, unless already found one, then
c                 info already set, use it
                call cg_goto_f(cg,base,ier,'end')
                if (ier.eq.ERROR) call cg_error_exit_f
                call cg_state_read_f(refstr,ier)
                if (ier.eq.ERROR) call cg_error_exit_f
                if ( ier .eq. ALL_OK ) then
                  iref = 2
                  write(6,*) '  Reference state found under base node'
                  call cg_goto_f (cg,base,ier,
     .                            'ReferenceState_t', 1, 'end')
                else
                  fsmach=0.0
                  alpha=0.0
                  re=0.0
                  runno=0.0
                  write(6,*)'  No Referencestate found'
                endif              
              endif
c
              if ( iref .gt. 0 ) then
                fsmach=0.0
                alpha=0.0
                re=0.0
                runno=0.0
c
c               Read type of data
                call cg_dataclass_read_f ( iclass, ier )
                if ( ier .eq. ERROR ) then
                  call cg_error_exit_f
                else if ( ier .eq. NODE_NOT_FOUND ) then
c                 plot3d only needs non-dim data, assumed if node not found
                else
c                 plot3d only needs non-dim data, so ok
                end if
c
c               Read units
                call cg_units_read_f ( imass, ilen, itime, 
     &                                 itemp, iangle, ier)
                if ( ier .eq. ERROR ) then
                  call cg_error_exit_f
                else if ( ier .eq. NODE_NOT_FOUND ) then
c                 assume this is because DataClass was also not defined and
c                 only non-dimensional data is stored
                else if ( iangle .ne. Degree ) then
c                 correct below
                end if
c
c               look for the right data
c
                call cg_narrays_f ( narrays, ier )
                if ( ier .eq. ERROR ) call cg_error_exit_f
                do iarray=1,narrays
c
                  call cg_array_info_f ( iarray, name, DataType, DataDim
     &                          ,DimVal, ier)
                  if ( ier .eq. ERROR ) call cg_error_exit_f
                  if ( DataDim.ne.1 .or. DataType.ne.RealSingle ) then
                    print *, '  ERROR: Can only deal with scalar, ',
     &               'real reference data'
                    return
                  end if
                  if ( trim(name) .eq. 'Reynolds' ) then
                    call cg_array_read_f ( iarray, data_sin, ier )
                    if ( ier .eq. ERROR ) call cg_error_exit_f
                    re = data_sin
                  else if ( trim(name) .eq. 'Mach' ) then
                    call cg_array_read_f ( iarray, data_sin, ier )
                    if ( ier .eq. ERROR ) call cg_error_exit_f
                    fsmach = data_sin
                  else if ( trim(name) .eq. 'VelocityAngleX' ) then
                    call cg_array_read_f ( iarray, data_sin, ier )
                    if ( ier .eq. ERROR ) call cg_error_exit_f
                    alpha = data_sin
                  end if
                end do       !loop through ReferenceState arrays
              end if
c
              if ( iref .ge. 0 ) then
                write(6,'(/a27,2f8.3,e15.6,f8.3)')
     .         ' fsmach, alpha, re, runno =', fsmach, alpha, re, runno
                write(6,'(/a42)')
     .                    ' are these correct?  1 for yes, else non-1'
                read (5,*) imore
                if (imore.ne.1) then
                  write(6,'(/a39)')
     .                         ' enter correct fsmach, alpha, re, runno'
                  read (5,*) fsmach, alpha, re, runno
                endif
                iref = -1
              end if
c
c      formatted, single precision
c      formatted, double precision
c      unformatted/binary, single precision
c      unformatted/binary, double precision
c
              write(6,*)'nsize',nsize
              write(6,*)'istor',istor
              write(6,*)'iprec',iprec
              write(6,*)'itype',itype
              write(6,*)'nfields',nfields
c             write(6,*)'Dval', Dvalues0

              if (istor.eq.1) write(iunit,*) fsmach, alpha, re, runno
              if (istor.ge.2) write(iunit  ) fsmach, alpha, re, runno
              if (istor.eq.1.and.iprec.eq.1) write(iunit,*)
     .           (( values0(pos,field), pos=1,nsize), field=1,nfields)
              if (istor.eq.1.and.iprec.eq.2) write(iunit,*)
     .           ((Dvalues0(pos,field), pos=1,nsize), field=1,nfields)
              if (istor.ge.2.and.iprec.eq.1) write(iunit  )
     .           (( values0(pos,field), pos=1,nsize), field=1,nfields)
              if (istor.ge.2.and.iprec.eq.2) write(iunit  )
     .           ((Dvalues0(pos,field), pos=1,nsize), field=1,nfields)
c
            end if                 ! solution check
c
 	  enddo			! zone loop

 100 	format('    Mass units: ',a/'    Length units: ',a/
     &    '    Temperature units: ',a/'    Time units: ',a/
     &    '    Angle units:',a)
cjam
        return
c
 	end
